#include"FC2704.h"
#include"tim.h"
#include"key.h"
#include"global.h"
#include"leddisplay.h"
#include"adc.h"
#include"eeprom.h"

//struct TIMER_STRUCT timerStruct={0,0,0};
struct MOTOR_STRUCT motorStruct={15,5,2,15,0,0,5,0};

void dis_ctr(void);
void motor_ctr(void);
//void timer_ctr(void);
void beep_ctr(void);
void sleep_ctr(void);
void key_service(void);
void system_init(void);
void get_motor_current(void);

uint16_t tableProtectVoltage[61]=
{
806	,//	0	A
833	,//	0.1	A
861	,//	0.2	A
888	,//	0.3	A
916	,//	0.4	A
943	,//	0.5	A
971	,//	0.6	A
999	,//	0.7	A
1026	,//	0.8	A
1054	,//	0.9	A
1081	,//	1	A
1109	,//	1.1	A
1136	,//	1.2	A
1164	,//	1.3	A
1191	,//	1.4	A
1219	,//	1.5	A
1246	,//	1.6	A
1274	,//	1.7	A
1301	,//	1.8	A
1329	,//	1.9	A
1356	,//	2	A
1384	,//	2.1	A
1411	,//	2.2	A
1439	,//	2.3	A
1466	,//	2.4	A
1494	,//	2.5	A
1521	,//	2.6	A
1549	,//	2.7	A
1576	,//	2.8	A
1604	,//	2.9	A
1631	,//	3	A
1659	,//	3.1	A
1686	,//	3.2	A
1714	,//	3.3	A
1742	,//	3.4	A
1769	,//	3.5	A
1797	,//	3.6	A
1824	,//	3.7	A
1852	,//	3.8	A
1879	,//	3.9	A
1907	,//	4	A
1934	,//	4.1	A
1962	,//	4.2	A
1989	,//	4.3	A
2017	,//	4.4	A
2044	,//	4.5	A
2072	,//	4.6	A
2099	,//	4.7	A
2127	,//	4.8	A
2154	,//	4.9	A
2182	,//	5	A
2209	,//	5.1	A
2237	,//	5.2	A
2264	,//	5.3	A
2292	,//	5.4	A
2319	,//	5.5	A
2347	,//	5.6	A
2374	,//	5.7	A
2402	,//	5.8	A
2429	,//	5.9	A
2457	,//	6	A
};

/******************************************************************************************************
*      ƣvoid motor_adc_delay_judge(void)
*      ܣ100msִһΣʱһʱȥжǷﵽ
*  ڲmotorStruct.u8ADCDelayTime
*  ڲmotorStruct.
*      
*      ڣ20201211
*      ߣм
******************************************************************************************************/
void motor_adc_delay_judge(void)
{
  static uint8_t u8t=0;    
  if(motorStruct.u8ADCDelayEn==0)
  { 
    u8t++;
    if(u8t>=motorStruct.u8ADCDelayTime)
    {  
      u8t=0;    
      motorStruct.u8ADCDelayEn=1;
    }  
  }
  else
  {
    u8t=0;    
  }       
}
/******************************************************************************************************
*      ƣvoid motor_out(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201211
*      ߣм
******************************************************************************************************/
void motor_out(void)
{ 
  static uint8_t u8i=0;
  u8i++;
  if(u8i>20)
  u8i=0;   
  switch(motorStruct.u8motorStatus)
  {
    case MOTOR_FWD:        //ת
	  switch(u8i)
	  {
	    case 0:
        HIN2_PIN=0;LIN2_PIN=0;
        LIN_PIN=0;HIN_PIN=0;
		break;
		case 1:
        HIN2_PIN=0;LIN2_PIN=0;
        HIN_PIN=0;LIN_PIN=1;
		break;
		case 2:
        HIN2_PIN=0;LIN2_PIN=0;
        LIN_PIN=0;HIN_PIN=0;
		break;
		default:
        HIN2_PIN=0;LIN2_PIN=1;
        LIN_PIN=0;HIN_PIN=1;
		break;
	  }
	break;

	case MOTOR_REV:        //ת
	  switch(u8i)
	  {
	    case 0:
        HIN2_PIN=0;LIN2_PIN=0;        
        LIN_PIN=0;HIN_PIN=0;
		break;
		case 1:
        HIN2_PIN=0;LIN2_PIN=1;            
        LIN_PIN=0;HIN_PIN=0;
		break;
		case 2:
        HIN2_PIN=0;LIN2_PIN=0;            
        LIN_PIN=0;HIN_PIN=0;
		break;
		default:
        LIN2_PIN=0;HIN2_PIN=1;            
        HIN_PIN=0;LIN_PIN=1;
		break;
	  }
	break;

	case MOTOR_STOP://ֹͣ
      HIN2_PIN=0;
      LIN2_PIN=0;   
      HIN_PIN=0;
	  LIN_PIN=0;
	break;
  }
}
/******************************************************************************************************
*      ƣvoid read_dat_from_e2porom(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201120
*      ߣм
******************************************************************************************************/
#define ERR  1

#define  P1_ADDR          0x00   
#define  P2_ADDR          0x01   
#define  P3_ADDR          0x02  
#define  P4_ADDR          0x03  
#define  P6_ADDR          0x04   
//#define  P5_ADDR          0x04  
#define  CHECK_SUM_ADDR   0x05  
 

void read_dat_from_e2porom(void)
{
  uint8_t tmp=0,bitRead=0;
 //ϵȶȡE2PROMеֵ
  tmp=eepromRead(CHECK_SUM_ADDR);
  if(tmp==0xAF)
  {  
    tmp=eepromRead(P1_ADDR);
    if(tmp<=50)
    {
      motorStruct.u8ShutDownCurrent=tmp;      
    }
    else
    {
      bitRead=ERR;  
    }
	  
    tmp=eepromRead(P2_ADDR);
    if(tmp<=50)
    {
      motorStruct.u8CurrentProtectDelayTime=tmp;     
    }
    else
    {
      bitRead=ERR;
    }

    tmp=eepromRead(P3_ADDR);
    if(tmp<=50)
    {  
      motorStruct.u8MotorStartDelayTime=tmp;
    }
    else
    {
      bitRead=ERR;
    }

    tmp=eepromRead(P4_ADDR);
    if(tmp<=30)
    {  
      motorStruct.u8CurrentErr=tmp;
    }
    else
    {
      bitRead=ERR;
    } 
    tmp=eepromRead(P6_ADDR);
    if(tmp<=100)
    {  
      motorStruct.u8ADCDelayTime=tmp;
    }
    else
    {
      bitRead=ERR;
    }			  
  }
  else
  {
    bitRead=ERR;  
  }  
  if(bitRead==ERR)
  {
    eepromWrite(P1_ADDR,15);      
    eepromWrite(P2_ADDR,5);      
    eepromWrite(P3_ADDR,2);      
    eepromWrite(P4_ADDR,15); 
    eepromWrite(P6_ADDR,5); 	  
    eepromWrite(CHECK_SUM_ADDR,0xAF);  	
  }    
} 
/******************************************************************************************************
*       ƣvoid motor_ctr(void)
*       : п,Ƶתתֹͣ
*  ˵     : 100msִһ
*   structSwitch[SWITCH_K1].bitStatus  structLockedRotor.u16updateAdcValue
*   Ϊ
*       ڣ20201126
*       ߣм
******************************************************************************************************/
void motor_ctr(void)
{
  static uint8_t u8x=0,u8y=0,u8z=0,u8step=0;
  uint16_t u16tmp=0;
  u16tmp=tableProtectVoltage[motorStruct.u8ShutDownCurrent];
  
  switch(u8step)
  {
    case 0:
	if(structSwitch[SWITCH_K1].bitStatus)
	u8step=1;
	else
	u8step=3;  
	break;

	case 1:
	if(structSwitch[SWITCH_K1].bitStatus==0)
	u8step=3;

      if(motorStruct.u8motorStatus!=MOTOR_FWD) //Сתͷƽȥ
      {  
        if(motorStruct.u8ADCDelayTime!=0)
        motorStruct.u8ADCDelayEn=0;
        else
        motorStruct.u8ADCDelayEn=1;
        u8y++;
        if(u8y>(motorStruct.u8MotorStartDelayTime<<1))
        {
          u8y=0;
          motorStruct.u8motorStatus=MOTOR_FWD;
        }  
      } 
	  else          //ת
	  {
	    u8y=0;
	  }

      //ʱֹͣ 
      if(motorStruct.u8ADCDelayEn)
      {
        if(structLockedRotor.u16AdcFilterValue>u16tmp)
        {
          u8x++;      
          if(u8x>(motorStruct.u8CurrentProtectDelayTime<<1))
          {
            u8x=0;
            motorStruct.u8motorStatus=MOTOR_STOP;
		    u8step=2;
          }
        }
	    else
	    u8x=0;
      }    
	break;

	case 2:
    motorStruct.u8motorStatus=MOTOR_STOP;
	if(structSwitch[SWITCH_K1].bitStatus==0)
	u8step=3;
	break;

	case 3:
	if(structSwitch[SWITCH_K1].bitStatus)
	u8step=1;

      //ûСתͷ˻    
      if(motorStruct.u8motorStatus!=MOTOR_REV)
      {  
        if(motorStruct.u8ADCDelayTime!=0)
        motorStruct.u8ADCDelayEn=0;
        else
        motorStruct.u8ADCDelayEn=1;
        u8z++;
        if(u8z>(motorStruct.u8MotorStartDelayTime<<1))
        {
          u8z=0;
          motorStruct.u8motorStatus=MOTOR_REV;
        }  
      }
	  else
	  {
	    u8z=0;
	  }
      //ʱֹͣ 
      if(motorStruct.u8ADCDelayEn)
      {
        if(structLockedRotor.u16AdcFilterValue>u16tmp)
        {
          u8x++;      
          if(u8x>(motorStruct.u8CurrentProtectDelayTime<<1))
          {
            u8x=0;
            motorStruct.u8motorStatus=MOTOR_STOP;
		    u8step=4;
          }
        }
	    else
	    u8x=0;
      }
	break;

	case 4:
    motorStruct.u8motorStatus=MOTOR_STOP;
	if(structSwitch[SWITCH_K1].bitStatus)
	u8step=1;
	break;
  }                
} 

/******************************************************************************************************
*       ƣvoid get_motor_current(void)
*       : 
*  ˵     : 50msִһ
*   
*   
*       ڣ2020121
*       ߣм
******************************************************************************************************/
void load_value_to_adt(void)
{
  if(structLockedRotor.u8adtEn)
  {
    structLockedRotor.u8adtEn=0;
    ADM=0x00;
    if(motorStruct.u8CurrentErr<15)
    { 
      ADT=15-motorStruct.u8CurrentErr;
      //disStruct.u8ten=MARK;//ʾ-  
      //disStruct.u8one=15-motorStruct.u8CurrentErr;             
    }
    else
    {
	  ADT=motorStruct.u8CurrentErr-15;
      ADT|=0x10;  
      //disStruct.u8ten=SPACE;//ʾո
     //disStruct.u8one=motorStruct.u8CurrentErr-15;            
    }
	//structLockedRotor.bitFinish=0;
	adc_init();
  }  
}
/******************************************************************************************************
*       ƣvoid get_motor_current(void)
*       : ݵϵĵѹѯӦĵ
*  ˵     : 50msִһ
*   structLockedRotor.u16AdcFilterValue
*   disStruct.u8motorCurrent  
*       ڣ20201130
*       ߣм
******************************************************************************************************/
void get_motor_current(void)
{
  static uint8_t u8x=0;
  uint8_t u8i=0;
  for(u8i=0;u8i<61;u8i++)
  {      
    if(structLockedRotor.u16AdcFilterValue<=tableProtectVoltage[u8i])  
    break;  
  }

  if(motorStruct.u8motorCurrent!=u8i)
  {
    u8x++;
	if(u8x>9)
    motorStruct.u8motorCurrent=u8i;
  }
  else
  {
    u8x=0; 
  }  
}  
/******************************************************************************************************
*       ƣvoid dis_ctr(void)
*       : ܼLEDʾ
*  ˵     : 100msִһ
*   
*   disStruct.u8ten     disStruct.u8one  
*       ڣ202065
*       ߣм
******************************************************************************************************/
void dis_ctr(void)
{ 
  if(disStruct.u8second==0)
  {
    disStruct.bitDp1=0;
    disStruct.u8ten=P_CODE;
    disStruct.u8one=disStruct.u8first;
  }
  else
  {
    disStruct.bitDp1=1;
  }  
  
  switch(disStruct.u8first)
  {
    case _P1://_P1 
      if(disStruct.u8second)
      {       
        disStruct.u8one=motorStruct.u8ShutDownCurrent%10;
        disStruct.u8ten=motorStruct.u8ShutDownCurrent/10;
      }  
    break;
    
    case _P2://_P2 ʱʱ
      if(disStruct.u8second)
      {       
        disStruct.u8ten=motorStruct.u8CurrentProtectDelayTime/10;
        disStruct.u8one=motorStruct.u8CurrentProtectDelayTime%10; 
      }  
    break;
    
    case _P3://_P3 ʱʱ
      if(disStruct.u8second)
      {  
        disStruct.u8ten=motorStruct.u8MotorStartDelayTime/10;
        disStruct.u8one=motorStruct.u8MotorStartDelayTime%10;       
      }   
    break;    
    
    case _P4:                  //_P4 ޸ʵʵʾ
      disStruct.bitDp1=0;
      if(disStruct.u8second)
      {  
        if(motorStruct.u8CurrentErr<15)
        {
          disStruct.u8ten=MARK;//ʾ-  
          disStruct.u8one=15-motorStruct.u8CurrentErr;             
        }
        else
        {
          disStruct.u8ten=SPACE;//ʾո
          disStruct.u8one=motorStruct.u8CurrentErr-15;            
        }     
      }  
    break;         
    
    case _P5://_P5 ʾ
      disStruct.bitDp1=1;
      disStruct.u8ten=motorStruct.u8motorCurrent/10;
      disStruct.u8one=motorStruct.u8motorCurrent%10;   
    break;  
    
    case _P6:     //ʾP6
      if(disStruct.u8second)
      {      
        //˲ʱ  
        if(motorStruct.u8ADCDelayTime!=100)
        {
          disStruct.u8ten=motorStruct.u8ADCDelayTime/10;
          disStruct.u8one=motorStruct.u8ADCDelayTime%10;
        }
        else
        {
          disStruct.bitDp1=0;
          disStruct.u8ten=1;
          disStruct.u8one=0;
        }             
      }
	  else
      {
	      disStruct.u8one=5; 
      }
    break;       
  }   
}
/******************************************************************************************************
*      ƣvoid sleep_ctr(void)
*      ܣ
*  ˵    ˯߿ƣɻ
*  ڲ̰־λ
*  ڲ
*      
*      ڣ2020516
*      ߣм
******************************************************************************************************/
void sleep_ctr(void)
{
#if 0  
  
  if(fogWindStruct.u8satus)
  return;
  
  system_init();
  while(1)
  {
    delay_1ms(10);
    scan_key();
    if(structKey[K1].bitLock==0)
    break;	
  }  
//  INTEN=0x20;
  do
  {
  //  INTRQ=0;  
  //  __asm{SleepMode};
  }while(P_KEY_K1);
  
//  INTEN=0x00;
//  INTRQ=0x00;
  t4_enable();
  structKey[K1].bitShortClick=1;  
  structKey[K1].bitLock=1;
#endif  
}
/******************************************************************************************************
*      ƣvoid key_service(void)
*      ܣ
*  ڲstructKey.u8KeyValue         structKey.bitShortClick
*  ڲ
*  ˵    
*      
*      ڣ202064
*      ߣм
******************************************************************************************************/
void key_service(void)
{
  if(structKey.bitShortClick)
  {
    structKey.bitShortClick=0;


	   switch(structKey.u8KeyValue)
	   {
      case 0x01://K1


        switch(disStruct.u8first)
        {
          case _P1:
            if(disStruct.u8second==NO_DIS) 
            {
              disStruct.u8second=DIS;
            }
            else
            {
              disStruct.u8second=NO_DIS;
              disStruct.u8first=_P2;
            }  
          break;
          
          case _P2:
            if(disStruct.u8second==NO_DIS) 
            {
              disStruct.u8second=DIS;
            }
            else
            {
              disStruct.u8second=NO_DIS;
              disStruct.u8first=_P3;
            }              
          break;
          
          case _P3:
            if(disStruct.u8second==NO_DIS) 
            {
              disStruct.u8second=DIS;
            }
            else
            {
              disStruct.u8second=NO_DIS;
              disStruct.u8first=_P4;
            }             
          break;
          
          case _P4:
            if(disStruct.u8second==NO_DIS) 
            {
              disStruct.u8second=DIS;
            }
            else
            {
              disStruct.u8second=NO_DIS;
              disStruct.u8first=_P6;                    
			  structLockedRotor.u8adtEn=1;//ADC
            }              
          break;

          case _P6:
            if(disStruct.u8second==NO_DIS) 
            {
              disStruct.u8second=DIS;
            }
            else
            {
              disStruct.u8second=NO_DIS;
              disStruct.u8first=_P5;                 //ýصʾģʽ
              eepromWrite(P1_ADDR,motorStruct.u8ShutDownCurrent);      
              eepromWrite(P2_ADDR,motorStruct.u8CurrentProtectDelayTime);      
              eepromWrite(P3_ADDR,motorStruct.u8MotorStartDelayTime);      
              eepromWrite(P4_ADDR,motorStruct.u8CurrentErr);   
              eepromWrite(P6_ADDR,motorStruct.u8ADCDelayTime); 			             
            }              
          break;  
          
          //case _P5:
          //P5ģʽ¶̰üû   
          //break;    

          
        }  
      break;

      
      case 0x02://K2 
        switch(disStruct.u8first)
        {
          case _P1:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8ShutDownCurrent<50)
              motorStruct.u8ShutDownCurrent++;
            } 
          break;
          
          case _P2:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8CurrentProtectDelayTime<50)
              motorStruct.u8CurrentProtectDelayTime++;
            }             
          break;
          
          case _P3:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8MotorStartDelayTime<50)
              motorStruct.u8MotorStartDelayTime++;
            }             
          break;
          
          case _P4:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8CurrentErr<30)
              motorStruct.u8CurrentErr++;
            }             
          break;
          
          case _P6:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8ADCDelayTime<100)
              motorStruct.u8ADCDelayTime++;
            }             
          break;          
          
          //case _P5:
          //P5ģʽ¶̰üû   
          //break;               
        }
      break;
      
      case 0x04://K3
        switch(disStruct.u8first)
        {  
          case _P1:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8ShutDownCurrent>0)
              motorStruct.u8ShutDownCurrent--;
            } 
          break;
          
          case _P2:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8CurrentProtectDelayTime>0)
              motorStruct.u8CurrentProtectDelayTime--;
            }             
          break;
          
          case _P3:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8MotorStartDelayTime>0)
              motorStruct.u8MotorStartDelayTime--;
            }             
          break;
          
          case _P4:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8CurrentErr>0)
              motorStruct.u8CurrentErr--;
            }   
          break;   

          case _P6:
            if(disStruct.u8second==DIS) 
            {
              if(motorStruct.u8ADCDelayTime>0)
              motorStruct.u8ADCDelayTime--;
            }             
          break;
         
	       }
      break;
    }
  }
  if(structKey.bitLongClick)
  {
    structKey.bitLongClick=0;
    if(structKey.u8KeyValue==0x01)
    {
      disStruct.u8second=NO_DIS;
      disStruct.u8first=_P1;     //ʾP1  
    }  
  }   
} 
/******************************************************************************************************
*      ƣvovoid system_init(void)
*      ܣϵͳʼ
*  ڲ    
*  ڲ
*      ڣ2020.6.10
*      ߣм
******************************************************************************************************/
void system_init(void)
{
  ADPCON=0x00;     
  ADR  =0x00;      //
  VREFH=0x00;      //内部参考电?  VDD:0x03   4.0V:0x02   3.0V:0x01    2.0V:0x00
  ADM  =0x00;      //

  T0M=0x00;	
  T0IE=0; 
  TM1M =0x00;   
  TM2M =0x00;
  PWM1E=0x00;
  PWM2E=0x00;
  FGIE=0;
	
  P1   =0x00;
  P1M  =0xFF;       //0 =      1 =  
  P1W  =0x00;  
  P1UR =0x00;      

  P2   =0x00;
  P2M  =0xFB;       //0 =      1 =  
  P2W  =0x00;  
  P2UR =0x04;      
  
  P3   =0x00;       
  P3M  =0x67;       
  P3W  =0x00;       
  P3UR =0x18;       //0 =     1 = 
}

